/*
 *  
 *  Copyright (c) 2004 Steve Slaven, All Rights Reserved.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307 USA
 *  
*/
package net.hoopajoo.cheeselab3;

import java.util.Arrays;

// This is a simple player
class CheesePlayerData extends java.lang.Object implements java.io.Serializable {
    /* This was generated by running serialver on this class in 2005.10.11
     * We should not change this unless we know that the class signature or communication protocol
     * has been changed so much that old clients have no way to work anymore
     */
    static final long serialVersionUID = 1675674564462909324L;

    String	name;

    int	x,y,z,roomid;

    boolean online;

    int	mana_curr, mana_max,
    hit_curr, hit_max,
    move_curr, move_max;

    String preferences;
    String permissions;

    String[] future;

    public boolean has_permission( String p ) {
        if( permissions == null )
            return( false );

        return( permissions.indexOf( p ) != -1 );
    }

    public boolean can_save() {
        return( has_permission( "A" ) || has_permission( "s" ) );
    }

    public boolean can_modify_users() {
        return( has_permission( "A" ) || has_permission( "u" ) );
    }

    public boolean is_administrator() {
        return( has_permission( "A" ) );
    }

    /*
    public boolean has_preference( String p ) {
    	if( preferences == null )
    		return( false );
    	
    	return( preferences.indexOf( p ) != -1 );
    }
    */

    public String toString() {
        return name + (online ? " - online" : "" );
    }

    public boolean equals(Object obj) {
        CheesePlayerData p;
        
        if (obj != null && (obj.getClass().equals(this.getClass())))
            p = (CheesePlayerData)obj;
        else
            return false;
    
        /* Now this code is just plain boring. But it's definately faster
         * than serializing both objects and comparing the resulting byte arrays.
         */

        if( !name.equals(p.name) )
            return false;
        if( x != p.x )
            return false;
        if( y != p.y )
            return false;
        if( z != p.z )
            return false;
        if( roomid != p.roomid )
            return false;
        if( online != p.online )
            return false;
        if( mana_curr != p.mana_curr )
            return false;
        if( mana_max != p.mana_max )
            return false;
        if( hit_curr != p.hit_curr )
            return false;
        if( hit_max != p.hit_max )
            return false;
        if( move_curr != p.move_curr )
            return false;
        if( move_max != p.move_max )
            return false;
        if( !compare_objs( preferences, p.preferences ) )
            return false;
        if( !compare_objs( permissions, p.permissions ) )
            return false;
        if( !Arrays.equals(future, p.future) )
            return false;

        return true;
    }

    private boolean compare_objs(Object o1, Object o2 ) {
        if( o1 == null && o2 != null )
            return false;
        if( o2 == null && o1 != null )
            return false;
        if( o1 == null && o2 == null )
            return true;

        return o1.equals( o2 );
    }
}
